using UnityEngine;
using System.Collections;

public class test1 : MonoBehaviour {

	public Terrain terrain;
	public float Tiling = 10.0f;
	
	// Use this for initialization
	void Awake () {
		Terrain terrain;
		Texture2D heightmap;
		
		Debug.Log("Start!!!!!");
		TerrainData terData = new TerrainData();
		GameObject flatTerr = Terrain.CreateTerrainGameObject(terData);
		flatTerr.name = "flattenTerrain";
		terrain = flatTerr.GetComponent<Terrain>();
		terrain.terrainData = terData;
		
		terrain.terrainData.heightmapResolution = 512;
		Vector3 newSize = new Vector3(2000, 600, 2000);
		terrain.terrainData.size = newSize;
		
//print(terrain.terrainData.size);
		
		float[,] heights = new float[513, 513];
		terData.SetHeights(0, 0, heights);
		terrain.terrainData.baseMapResolution = 512;
		
		/* Try to put texture*/
		//heightmap =  Resources.Load("rawTerr", typeof(Texture2D)) as Texture2D;
		heightmap =  Resources.Load("rawTerr") as Texture2D;
//print("texture="+heightmap);
		int w = heightmap.width;
		int h = heightmap.height;
		int w2 = terrain.terrainData.heightmapWidth;
		//print( terrain.terrainData.GetHeights(0, 0, w2, w2));
//		TerrainData heightmapData = terrain.terrainData.GetHeights(0, 0, w2, w2);
		float[,] heightmapData = terrain.terrainData.GetHeights(0, 0, w2, w2);
//print("w="+w+", h="+h+", w2="+w2);
		Color[] mapColors = heightmap.GetPixels();
		Color[] map = new Color[w2*w2];

		if(w2!=w || h!=w)
		{
			if(heightmap.filterMode == FilterMode.Point)
			{
				float dx = (float)(w/w2);
				float dy = (float)(h/w2);
				for(int y=0; y<w2;y++ )
				{
					int thisY = (int)(dy*y)*w; //parseInt(dy*y)*w;
					int yw = y*w2;
					for(int x=0;x<w2;x++)
					{
						map[yw+x] = mapColors[thisY+(int)dx*x];
					}
				}
			}
		    else {
			  float ratioX = 1.0f/(float)(w2/(w-1));
			  float ratioY = 1.0f/(float)(w2/(h-1));
			  for(int y=0;y<w2;y++)
			  {
                    int yy = (int)Mathf.Floor(y*ratioY); 
                    int y1 = (int)yy*w; 
                    int y2 = (int)(yy+1)*w; 
                    int yw = y*w2; 
                    for(int x=0;x<w2;x++) 
                    { 
                        int xx = (int)Mathf.Floor(x*ratioX); 
//print("xx="+xx);                     
					    Color b1 = mapColors[y1+xx];
					    Color br = mapColors[y1+xx+1];
					    Color t1 = mapColors[y2+xx];
					    Color tr = mapColors[y2+xx+1];
//print("yy="+yy+",y1="+y1+".y2="+y2+",yw="+yw+",xx="+xx);					
					    float xLerp = (float)x*ratioX-xx;
				 	    map[yw+x] = Color.Lerp(Color.Lerp(b1, br, xLerp), Color.Lerp(t1, tr, xLerp), y*ratioY-yy);
				    }
			   }
		    }
	    }
	     else {
		  map = mapColors;
	    }
	
	for(int y=0;y<w2;y++)
	{
		for(int x=0;x<w2;x++)
		{
			heightmapData[y,x] = map[y*w2+x].grayscale;
		}
	}
	terrain.terrainData.SetHeights(0, 0, heightmapData);

		//------>GenerateHeights(terrain.GetComponent<Terrain>(), Tiling);
		
		//string imagePath = Application.dataPath;
		//print("Data Path="+imagePath);
		/*
		IEnumerator Start() {
		   WWW www = new WWW("file://"+imagePath+"/rawTerr.jpg");
		   yield return www;
		   //render.material.mainTexture = www.texture;
		   //www.LoadImageIntoTexture(tex);
		}*/
	}
	
	public void GenerateHeights(Terrain terrain, float tileSize){
		
		float[,] heights = new float[terrain.terrainData.heightmapWidth, terrain.terrainData.heightmapHeight];
		
		for (int i = 0; i < terrain.terrainData.heightmapWidth; i++)
        {
            for (int k = 0; k < terrain.terrainData.heightmapHeight; k++)
            {
                heights[i, k] = Mathf.PerlinNoise(((float)i / (float)terrain.terrainData.heightmapWidth) * tileSize, ((float)k / (float)terrain.terrainData.heightmapHeight) * tileSize)/10.0f;
            }
        }

        terrain.terrainData.SetHeights(0, 0, heights);
	}
	// Update is called once per frame
	void Update () {
	
	}
}
